package se.gawell.kvtstore.core.jackson;

import org.codehaus.jackson.map.ObjectMapper;
import org.springframework.stereotype.Component;

import se.gawell.kvtstore.core.Deserializer;

@Component
public class JacksonDeserializer implements Deserializer {

	private ObjectMapper objectMapper = new ObjectMapper();
	
	@SuppressWarnings("unchecked")
	@Override
	public <type> type deserialize(String serializedObject, Class<? extends Object> type) {
		try {
			return (type) objectMapper.readValue(serializedObject.getBytes(), type);
		} catch (Exception e) {
			throw new SerializingException(e);
		}
	}

}
